#!/bin/bash

source /Node/bin/env.sh

if test "$backupdir" == "" ; then
	backupdir="/backup"
fi

if test "$DBS" == "" ; then
  echo "Please define variable DBS in /Node/bin/env.sh containing the databases to dump."
  exit 1
fi

for db in $DBS; do
echo "DROP DATABASE IF EXISTS $db; CREATE DATABASE $db" | /Node/mysql/bin/mysql -u root;
done


for db in $DBS; do
/Node/mysql/bin/mysql --default-character-set=utf8 $db < $backupdir/$db.struct.sql
zcat $backupdir/$db.data.sql.gz | /Node/mysql/bin/mysql --default-character-set=utf8 $db; done



