<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="html" />
  <xsl:template match="*" />

  <xsl:template match="bundle">
    <html>
      <head>
        <title>Bundle "<xsl:value-of select="bundleinfo/name" />"</title>
        <link rel="stylesheet" type="text/css" href="?do=11&amp;url=lib/xsl/bundle.css" />
      </head>
      <body>
        <div class="content">
          <div class="header">
            <h1><xsl:value-of select="bundleinfo/name" /></h1>
            <h3>Source system: <xsl:value-of select="bundleinfo/sourcehost" /></h3>
          </div>
          <p class="bundle">
            <xsl:value-of select="bundleinfo/description" />
          </p>
          <xsl:apply-templates />
        </div>
      </body>
    </html>
  </xsl:template>


  <xsl:template match="builds">
    <h2>Exportfiles</h2>
    <ul class="builds">
      <xsl:apply-templates />
    </ul>
  </xsl:template>

  <xsl:template match="objects">
    <h2>Contained objects of latest build</h2>
    <table class="objects">
      <tr>
        <th>Type</th>
        <th>Name</th>
      </tr>
      <xsl:apply-templates />
    </table>
  </xsl:template>

  <xsl:template match="build">
    <li class="build">
      <p>
        <strong>Date:</strong> <xsl:value-of select="humanbuilddate" />
      </p>
      <p>
        <xsl:value-of select="changelog" />
      </p>
      <xsl:if test="string-length(downloadurl) != 0">
        <p class="download">
          <xsl:element name="a">
            <xsl:attribute name="href"><xsl:value-of select="downloadurl" /></xsl:attribute>
            Download
          </xsl:element>
        </p>
      </xsl:if>
    </li>
  </xsl:template>

  <xsl:template match="object">
    <tr>
      <td><xsl:value-of select="humantype" /></td>
      <td><xsl:value-of select="humanname" /></td>
    </tr>
  </xsl:template>

</xsl:stylesheet>