<?php

define ( "MAP_PTYPE_NAME", 0 );
define ( "MAP_PTYPE_EXTLINK", 1 );

class CNMapObject extends CNObject {
 var $m_mapId = 0;
 
 function CNMapObject( $id = 0 )
 {
 parent::CNObject($id);
 }
 
 function getTType()
 {
 global $T_MAP;
 return $T_MAP;
 }
 
 function getIcon() {
 global $ICO_MAP;
 return $ICO_MAP;
 }
 
 function _setID($id) {
 $this->m_mapId = $id;
 }
 
 function getID() {
 return (int) $this->m_mapId;
 }
 
 function getValueFields() {
 return array( "name"=>false, "keyword"=>"text", "description"=>"textarea",
 "node_id"=>false );
 }
 
 function &getFormObject() { return new CNMapFormObject($this); }
 
 function _getNodeTable() { return "cn_map"; }

 function getPropertyNames() {
 return array_merge(parent::getPropertyNames(), array("name"=>i18n("Name") ) );
 }
 
 function& getProperty( $key )
 {
 switch ( $key )
 {
 case "name":
 $name = $this->getFieldValue( "name" );
 if ( !$name ) $name = "-";
 return new StringObject($name);
 case "keyword":
 return new StringObject( $this->getFieldValue( "keyword" ) );
 case "xml":
 return new StringObject( $this->getXML() );
 default:
 return parent::getProperty($key);
 } 
 }

 function &getChilds()
 {
 global $T_MAP_ENTRY;
 $ret = new NodeObjectCollection( $T_MAP_ENTRY );
 $sql = "SELECT * FROM cn_map WHERE mother_id=".sqlf_tl_num($this->getID());
 $rs = query( $sql, true);
 foreach ( $rs["arr"] as $value )
 {
 unset($class);
 $class = new CNMapObject($value["id"]);
 $class->setFieldValue("node_id", $this->d_nodeId);
 $class->setFieldValue("mother_id", $this->getID());
 $class->setFieldValue("keyword", $value["keyword"]);
 $class->setOuterClass( $this );
 $ret->add($class);
 
 }
 return $ret; 
 }
}

class CNMapEntryObject extends CNObject {
 var $m_mapId = 0;
 var $m_name = NULL;
 var $m_links_int = NULL;
 var $m_links_int_id = NULL;
 var $m_links_ext = NULL;
 var $m_linksInitialized = FALSE;
 var $m_predefinedTargets = array();

 







 function CNMapEntryObject( $id = 0 )
 {
 $this->setID($id);
 $this->m_predefinedTargets = array(
 "_blank" => i18n( "New Window" )
 );
 }
 
 function getTType()
 {
 global $T_MAP_ENTRY;
 return $T_MAP_ENTRY;
 }
 
 function getIcon() {
 global $ICO_MAP_ENTRY;
 return $ICO_MAP_ENTRY;
 }
 
 function getObjectKey()
 {
 return $this->getFieldValue( "keyword" );
 }
 
 function _setID($id) {
 $this->m_mapId = $id;
 }
 
 function getID() {
 return (int) $this->m_mapId;
 }
 
 function setNodeId($nodeId) {
 $this->setFieldValue("node_id", (int) $nodeId);
 }

 function setMotherId($motherId) {
 $this->setFieldValue("mother_id", (int) $motherId);
 }
 
 function setKeyword($key) {
 $this->setFieldValue("keyword", $key);
 }
 
 




 function isMap()
 {
 return strlen($this->getFieldValues("keyword")) > 0; 
 }
 
 function _updateLinks()
 {
 $id = $this->getID();
 $lang = $this->_getLanguage();
 $code = sqlslashes( $lang["code"] );

 $sql = "DELETE FROM cn_mapprop ".
 "WHERE cn_map_id=".sqlf_tl_num($id).
 " AND ptype=".sqlf_tl_num(MAP_PTYPE_EXTLINK) . " AND pkey='".sqlf_escaped($code)."'"; 
 query( $sql );
 
 $value = sqlslashes( $this->m_links_ext[$lang["code"]] );
 $sql = "INSERT INTO cn_mapprop ( cn_map_id, ptype, pkey, value ) ".
 "VALUES ( ".sqlf_tl_num($id).", ".sqlf_tl_num(MAP_PTYPE_EXTLINK).", '".sqlf_escaped($code)."', '".sqlf_escaped($value)."' )";
 query( $sql );
 $this->m_linksInitialized = FALSE;
 }
 
 function _initLinks()
 {
 if ( $this->m_linksInitialized ) return;
 $id = $this->getID();
 if ( !$id ) return;
 $sql = "SELECT pkey, value FROM cn_mapprop WHERE ptype=".sqlf_tl_num(MAP_PTYPE_EXTLINK).
 " AND cn_map_id=".sqlf_tl_num($id);
 $rs = query( $sql );
 $this->m_links_ext = array();
 foreach ( $rs["arr"] as $row )
 {
 $this->m_links_ext[$row["pkey"]] = $row["value"];
 }
 $this->m_links_int = array();
 $this->m_links_int_id = array();
 $pid = $this->getFieldValue( "page_id" );
 $node_id = $this->getFieldValue("node_id");
 if ( $pid )
 { 
 $cgs = get_contentgroups();
 foreach ( $cgs as $cgKey=>$lang )
 {
 $id = CNPageObject::getLangPageId( $pid, $cgKey );
 $this->m_links_int[$lang["code"]] = make_link('page', $id, $node_id); 
 $this->m_links_int_id[$lang["code"]] = $id; 
 }
 }
 $this->m_linksInitialized = true;
 }
 
 function getPageLinkIds() {
 $this->_initLinks();
 return $this->m_links_int_id;
 }
 
 function getPageLinks() {
 $this->_initLinks();
 return $this->m_links_int;
 }
 
 function getExtLinks() {
 $this->_initLinks();
 return $this->m_links_ext;
 }
 
 function getLinks() {
 return ($this->getFieldValue("is_link_int") == 1)?$this->getPageLinks():$this->getExtLinks();
 }
 
 
 function getMapName( $mapId, $node_id=false, $cgId = false )
 {
 
 global $CONTENTGROUP_ID, $NODE_ID;
 if ( !$node_id ) $node_id = $NODE_ID;
 if ( !$node_id ) halt( 101, "No valid node_id for getMapName" );
 
 if ( !$cgId ) $cgId = $CONTENTGROUP_ID;
 $cgs = get_contentgroups($node_id);
 if ( !$cgId ) {
 $cgId = key($cgs);
 }
 if ( !$cgId ) halt( 107, "MapObject::getMapName: no contentgroup-id" );

 $last = FALSE;
 $cg = $cgs[$cgId];
 do
 { 
 $code = sqlslashes($cg["code"]); 
 $sql = "SELECT value FROM cn_mapprop WHERE ptype=".sqlf_tl_num(MAP_PTYPE_NAME).
 " AND pkey='".sqlf_escaped($code)."' AND cn_map_id=".sqlf_tl_num($mapId);
 $rs = query( $sql );
 $name = $rs["arr"][0]["value"];
 $cg = next( $cgs );
 } while ( !$name && $cg );
 return $name?$name:"-";
 }
 
 function isInternalLink() {
 return ($this->getFieldValue("is_link_int") == 1);
 }
 
 function initFromKey($nodeId, $key = "", $motherId = 0) {
 $dbKey = sqlslashes( $key );
 $nodeId = (int) $nodeId;
 $motherId = (int) $motherId;
 $sql = "SELECT id FROM cn_map WHERE keyword = '".sqlf_escaped($dbKey)."' AND mother_id = ".sqlf_tl_num($motherId)." AND node_id = ".sqlf_tl_num($nodeId);
 $rs = query($sql);
 if ($rs["num"] != 1) return false;
 $this->setID($rs["arr"][0]["id"]);
 $this->setFieldValue("node_id", $nodeId);
 $this->setFieldValue("mother_id", $motherId);
 $this->setFieldValue("keyword", $key);
 return true;
 }
 
 function _initNames()
 {
 if ( $this->m_name !== NULL ) return;
 $this->m_name = array();
 $sql = "SELECT pkey, value FROM cn_mapprop WHERE ptype=".sqlf_tl_num(MAP_PTYPE_NAME).
 " AND cn_map_id=".sqlf_tl_num($this->getID());
 $rs = query( $sql );
 foreach ( $rs["arr"] as $row )
 {
 $this->m_name[$row["pkey"]] = $row["value"];
 }
 }
 
 function getNames()
 {
 $this->_initNames();
 return $this->m_name;
 }
 
 function getValueFields() {
 return array( "name"=>false, "keyword"=>"text", "page_id"=>false, "is_link_int"=>false, 
 "open_target"=>false, "description"=>"textarea", "mother_id"=>false, 
 "node_id"=>false);
 }
 
 function &getFormObject() { return new CNMapEntryFormObject($this); }

 function checkErrors( ) {
 $lang = $this->_getLanguage();
 $this->_initLinks();
 
 if (!$this->getFieldValue("page_id") && $this->getFieldValue("is_link_int") == 1) {
 $this->_setError(new NodeException(i18n("Please select a page.")), "is_link_int.1");
 return false;
 }
 if (!$this->m_links_ext[$lang["code"]] && $this->getFieldValue("is_link_int") == 2) {
 $this->_setError(new NodeException(i18n("Please enter a valid url.")), "is_link_int.2");
 return false;
 }
 
 if ( !$this->getFieldValue( "open_target" ) )
 {
 $this->_setError(new NodeException(i18n("Please select a link target.")), "open_target");
 return false;
 } 
 $mother_id = $this->getFieldValue("mother_id");
 $name = $this->m_name[$lang["code"]];
 $keyword = sqlslashes($this->getFieldValue("keyword"));
 
 if ( !$name )
 {
 $this->_setError(new NodeException(i18n("Please enter a name.")), "name" );
 }
 
 $sql = "SELECT id  FROM cn_map WHERE mother_id=".sqlf_tl_num($mother_id)." AND keyword LIKE '".sqlf_escaped($keyword)."' AND id != ".sqlf_tl_num($this->getID());
 $rs = query($sql);
 if ($rs["num"] > 0) {
 $this->_setError(new NodeException(i18n("This keyword is already in use in this branch.")), "keyword");
 return false;
 }
 return true;
 }

 function _getNodeTable() { return "cn_map"; }
 
 function _initDefaults() {
 $this->setFieldValue('is_link_int', 3);
 return true;
 }
 
 function _getLanguage()
 {
 global $CONTENTGROUP_ID;
 $cg = get_contentgroups();
 if ( !$CONTENTGROUP_ID ) $CONTENTGROUP_ID = key($cg);
 $lang = $cg[$CONTENTGROUP_ID];
 $lang["id"] = $CONTENTGROUP_ID;
 return $lang;
 }
 
 function _updateName()
 {
 $id = $this->getID();
 $lang = $this->_getLanguage();
 $code = sqlslashes( $lang["code"] );

 $sql = "DELETE FROM cn_mapprop ".
 "WHERE cn_map_id=".sqlf_tl_num($id).
 " AND ptype=".sqlf_tl_num(MAP_PTYPE_NAME) . " AND pkey='".sqlf_escaped($code)."'"; 
 query( $sql );
 
 $value = sqlslashes( $this->m_name[$lang["code"]] );
 $sql = "INSERT INTO cn_mapprop ( cn_map_id, ptype, pkey, value ) ".
 "VALUES ( ".sqlf_tl_num($id).", ".sqlf_tl_num(MAP_PTYPE_NAME).", '".sqlf_escaped($code)."', '".sqlf_escaped($value)."' )";
 query( $sql );
 }
 
 function onUpdateObject()
 {
 $this->_updateName();
 $this->_updateLinks();
 }
 
 function onInsertObject()
 {
 $this->_updateName();
 $this->_updateLinks();
 perm_grant_all( $this->getTType(), $this->getID() );
 }
 
 function _deleteObject() {
 $sql = "SELECT id FROM cn_map WHERE mother_id = ".sqlf_tl_num($this->getID());
 $rs = query($sql);
 $err = false;
 while (list($key, $val) = each($rs["arr"])) {
 $obj = new CNMapObject($val["id"]);
 if (!$obj->delete()) {
 if (!$err) $this->_setError(new NodeException(i18n("Could not delete all child objects.")));
 $err = true;
 }
 }
 if (!$err) {
 $sql = "DELETE FROM cn_map WHERE id = ".sqlf_tl_num($this->getID());
 query($sql);
 $sql = "DELETE FROM cn_mapprop WHERE cn_map_id =".sqlf_tl_num($this->getID());
 query($sql);
 }
 return $err;
 }
 
 function& _getChild( $key )
 {
 $class = new CNMapObject();
 if (!$class->initFromKey($this->getFieldValue("node_id"), $key, $this->getID()))
 return NULL;
 $class->setOuterClass( $this );
 return $class; 
 }
 
 function &getChilds()
 {
 global $T_MAP_ENTRY;
 $ret = new NodeObjectCollection( $T_MAP_ENTRY );
 $sql = "SELECT * FROM cn_map WHERE mother_id=".sqlf_tl_num($this->getID());
 $rs = query( $sql, true);
 foreach ( $rs["arr"] as $value )
 {
 unset($class);
 $class = new CNMapObject($value["id"]);
 $class->setFieldValue("node_id", $this->d_nodeId);
 $class->setFieldValue("mother_id", $this->getID());
 $class->setFieldValue("keyword", $value["keyword"]);
 $class->setOuterClass( $this );
 $ret->add($class);
 
 }
 return $ret; 
 }
 
 function getPropertyNames() {
 return array_merge(parent::getPropertyNames(), array("name"=>i18n("Name"), "childs"=>i18n("Childs")) );
 }
 
 function& getProperty( $key )
 {
 switch ( $key )
 {
 case "name":
 $this->_initNames();
 $lang = $this->_getLanguage();
 $name = $this->m_name[$lang["code"]];
 if ( !$name ) $name = "-";
 return new StringObject($name);
 case "motherid":
 return new IntObject($this->getFieldValue("mother_id"));
 case "mother":
 $class = &$this->getOuterClass();
 if ( $class === NULL )
 return new NodeException( "CNMapObject: This Map has no mother!" );
 else
 return $class;
 case "keyword":
 return new StringObject( $this->getFieldValue( "keyword" ) );
 case "xml":
 return new StringObject( $this->getXML() );
 default:
 return parent::getProperty($key);
 } 
 }

 function getLanguagesXML( $name, $links, $prefix )
 {
 if ( !is_array( $links ) ) 
 return $prefix.'<vmaps:'.$name.'></vmaps:'.$name.'>'."\n";
 $ret = ""; 
 foreach ( $links as $code => $link )
 {
 $ret .= $prefix.'<vmaps:'.$name.' code="'.$code.'">'.htmlentities_utf8($link).'</vmaps:'.$name.'>'."\n";
 }
 return $ret;
 }
 
 function getXML($level = 0, $prefix = '') {
 $mother_id = $this->getFieldValue( "mother_id" );
 if ( $mother_id != 0 ) 
 {
 $xml = $prefix.'<vmaps:map>'."\n";
 $iPrefix = $prefix.'  ';
 $xml .= $iPrefix.'<vmaps:level>'.$level.'</vmaps:level>'."\n";
 $xml .= $iPrefix.'<vmaps:id>'.$this->getID().'</vmaps:id>'."\n";
 $xml .= $this->getLanguagesXML( "name", $this->getNames(), $iPrefix );
 $xml .= $iPrefix.'<vmaps:keyword>'.htmlentities_utf8($this->getFieldValue("keyword")).'</vmaps:keyword>'."\n";
 $xml .= $this->getLanguagesXML( "link", $this->getLinks(), $iPrefix );
 $xml .= $this->getLanguagesXML( "pageid", $this->getPageLinkIds(), $iPrefix );
 

 $xml .= $iPrefix.'<vmaps:link_type>'.$this->getFieldValue("is_link_int").'</vmaps:link_type>'."\n";
 $xml .= $iPrefix.'<vmaps:open_target>'.$this->getFieldValue("open_target").'</vmaps:open_target>'."\n";
 $xml .= $iPrefix.'<vmaps:description>'.htmlentities_utf8($this->getFieldValue("description")).'</vmaps:description>'."\n";
 }
 else 
 $iPrefix = $prefix;
 
 
 
 $childs =& $this->getProperty("childs");
 if ( $childs->size() > 0 )
 $xml .= "$iPrefix<vmaps:virtualmaps>\n"; 

 $i = $childs->iterator();
 while ($i->hasNext()) {
 unset($next);
 $next = &$i->next();
 $xml .= $next->getXML($level + 1, $iPrefix.'  ');
 }

 if ( $childs->size() > 0 )
 {
 $xml .= "$iPrefix</vmaps:virtualmaps>\n";
 }
 
 if ( $mother_id != 0 )
 $xml .= $prefix.'</vmaps:map>'."\n";
 return $xml;
 }
}

class CNMapFormObject extends NodeFormObject {
 
 function getListHeaders() {
 return array( "name"=>i18n("Name"), "keyword"=>i18n( "Keyword" ) );
 }
 
 function getFieldLabels() {
 return array( "name" => i18n("Name"), "keyword" => i18n("Keyword"), 
 "description" => i18n("Description") );
 }

}

class CNMapEntryFormObject extends NodeFormObject {
 
 function getListHeaders() {
 return array( "name"=>i18n("Name"), "keyword"=>i18n( "Keyword" ) );
 }
 
 function getFieldLabels() {
 return array( "name" => i18n("Name"), "keyword" => i18n("Keyword"), 
 "description" => i18n("Description") );
 }

 function isEditableField($field) {
 return true;
 }

 function isOptionalField($field) {
 if ($field == "ext_link" || $field == "page_id") return true;
 else return false;
 }

 function &getFormComponent($field) {
 global $T_NODE;
 $obj =& $this->getEditObject();
 
 switch ($field) {
 case "open_target":
 node_class("componentchooser");
 node_class("selectcomponent");
 $val = $obj->getFieldValue( "open_target" );
 if ( in_array( $val, array_keys( $obj->m_predefinedTargets ) ) || !$val )
 {
 $sel = "pre";
 $preVal = $val;
 }
 else
 {
 $sel = "own";
 $ownVal = $val;
 }
 
 $comp = new ComponentChooser( i18n( "Open Target" ), $sel );
 $comp->setComponent( "pre", new SelectComponent( i18n("Select target"), $obj->m_predefinedTargets, $preVal, true ) );
 $comp->setComponent( "own", new TextComponent( i18n("Enter own target"), TRUE, $ownVal ) );
 
 break;
 case "name":
 $obj->_initNames();
 node_class( "textcomponent" );
 $lang = $obj->_getLanguage();
 $comp = new TextComponent( i18n( "Name" ), true, 
 $obj->m_name[$lang["code"]] );
 break;
 case "is_link_int":
 node_class("pageselector");
 node_class("minibrowserhiselector");
 node_class("textcomponent");
 node_class("componentchooser");
 $obj->_initLinks();
 $lang = $obj->_getLanguage();
 
 
 $node_id = $obj->getFieldValue("node_id");
 if ( $node_id ) {
 $sql = "SELECT id FROM folder WHERE node_id=".sqlf_tl_num($node_id)." AND mother = 0";
 $rs = query($sql, 1);
 $folder_id = $rs["arr"][0]["id"];
 }
 
 
 $page_id = $obj->m_links_int_id[$lang["code"]];
 $pageSelector = new PageSelector($folder_id, $T_NODE, 
 $page_id?$page_id:0);
 $pageSelector->enableDirectLanguageSelection( false );
 $intcomp = new MinibrowserHiSelector( $pageSelector, i18n("Internal Link") );

 
 $extcomp = new TextComponent( i18n("External Url"), TRUE, $obj->m_links_ext[$lang["code"]] );

 
 $comp = new ComponentChooser( i18n( "Link" ), $obj->getFieldValue("is_link_int") );
 $comp->setComponent( "1", $intcomp );
 $comp->setComponent( "2", $extcomp );
 $comp->setComponent( "3", new FormComponent( i18n( "No link" ) ) );
 break;
 default:
 $comp = false;
 }
 
 return $comp;
 }
 
 function storeFormComponent($field, &$comp) {
 global $CONTENTGROUP_ID;
 $obj =& $this->getEditObject();
 switch ($field) {
 case "open_target":
 $sel = $comp->getSelection();
 if ( $sel == "pre" )
 {
 $c = &$comp->getComponent( "pre" );
 $val = $c->getSingleSelection();
 if ( "$val" == "-9999" ) $val = ""; 
 } 
 else
 {
 $c = &$comp->getComponent( "own" );
 $val = $c->getText();
 }
 $obj->setFieldValue( "open_target", $val );
 break;
 case "name":
 $lang = $obj->_getLanguage();
 
 if ( $obj->getFieldValue("mother_id") == 0 )
 {
 $first = reset($lang);
 $obj->setFieldValue( "name", $comp->getText() );
 }
 else
 {
 $obj->m_name[$lang["code"]] = $comp->getText();
 }
 break;
 case "is_link_int":
 $obj->setFieldValue("is_link_int", (int)$comp->getSelection());
 $ilink =& $comp->getComponent( "1" );
 $obj->setFieldValue("page_id", $ilink->getResult());
 $lang = $obj->_getLanguage();
 $elink = $comp->getComponent( "2" );
 $obj->m_links_ext[$lang["code"]] = $elink->getText();
 break;
 }
 }
 
}

function mapobject_getmapname( $id, $node_id = false, $cgId = false )
{
 return CNMapEntryObject::getMapName( $id, $node_id, $cgId );
}

?>
